NewRaycastWeaponBase._weapon_tweak_data_edit_functions = NewRaycastWeaponBase._weapon_tweak_data_edit_functions or {}
table.insert( NewRaycastWeaponBase._weapon_tweak_data_edit_functions, "weapon_tweak_data_anim_adjust" ) 
table.insert( NewRaycastWeaponBase._weapon_tweak_data_edit_functions, "weapon_tweak_data_timer_adjust" ) 

function NewRaycastWeaponBase:weapon_tweak_data_anim_adjust( tweak_data )
	if not self._factory_id then return end
	if not self._blueprint then return end

	for index, part_id in ipairs(self._blueprint) do
		local real_data = managers.weapon_factory:get_part_data_by_part_id_from_weapon(part_id, self._factory_id, self._blueprint)

		if ( real_data.weapon_hold_override and real_data.weapon_hold_override[tweak_data.name_id] ) then
			tweak_data.weapon_hold = real_data.weapon_hold_override[tweak_data.name_id]
			if not ( real_data.weapon_stance_override and real_data.weapon_stance_override[tweak_data.name_id] ) then
				tweak_data.use_stance = real_data.weapon_hold_override[tweak_data.name_id] -- Mostly fixes the ironsights.
			end
		end

		if ( real_data.weapon_stance_override and real_data.weapon_stance_override[tweak_data.name_id] ) then
			tweak_data.use_stance = real_data.weapon_stance_override[tweak_data.name_id] -- Mostly fixes the ironsights.
		end

		if ( tweak_data.animations and real_data.weapon_reload_override and real_data.weapon_reload_override[tweak_data.name_id] ) then
			tweak_data.animations.reload_name_id = real_data.weapon_reload_override[tweak_data.name_id]
			tweak_data.animations.magazine_empty = nil -- If this value is set it sometimes causes the the slide on some guns to get stuck.
		end
	end
end

function NewRaycastWeaponBase:weapon_tweak_data_timer_adjust( tweak_data )
	if not tweak_data.timers then return end
	if not self._factory_id then return end
	if not self._blueprint then return end

	for index, part_id in ipairs(self._blueprint) do
		local real_data = managers.weapon_factory:get_part_data_by_part_id_from_weapon(part_id, self._factory_id, self._blueprint)
			
		if ( real_data.timer_multiplier ) then
			for timer, multiplier in pairs( real_data.timer_multiplier ) do
				if tweak_data.timers[timer] then
					tweak_data.timers[timer] = tweak_data.timers[timer] * multiplier
				end
			end
		end

		if ( real_data.timer_adder ) then
			for timer, adder in pairs( real_data.timer_adder ) do
				if tweak_data.timers[timer] then
					tweak_data.timers[timer] = tweak_data.timers[timer] + adder
				end
			end
		end
	end
end

function NewRaycastWeaponBase:weapon_tweak_data()
	if ( self._factory_id and self._blueprint ) and ( ( not self._patched_weapon_tweak_data ) or ( self._last_weapon_tweak_data_id ~= self:_weapon_tweak_data_id() ) ) and ( self._weapon_tweak_data_edit_functions ) then
		self._last_weapon_tweak_data_id = self:_weapon_tweak_data_id()

		local weapon_data = deep_clone(tweak_data.weapon[self._last_weapon_tweak_data_id])

		for index, func_name in ipairs(self._weapon_tweak_data_edit_functions) do
			self[func_name]( self, weapon_data )
		end

		self._patched_weapon_tweak_data = weapon_data
	end

	return self._patched_weapon_tweak_data or tweak_data.weapon[self:_weapon_tweak_data_id()]
end